Factoring.Web/Factoring.Web/Controllers/EmpresaController.cs
using Factoring.Web.Funcionalidad.Empresa;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Factoring.Web.Controllers
{
    public class EmpresaController : Controller
    {
        // GET: Empresa
        public ActionResult Lista(string usuario)
        {
            using (var empresa = new ListaEmpresaHandler())
            {
                var user = User.Identity.Name;
                ViewBag.Usuario = user;
                return View(empresa.Listar(user));
            }                
        }

        public ActionResult Ver(int id)
        {
            using (var empresa = new ListaEmpresaHandler())
            {
                return View(empresa.TraeUno(id));
            }
        }

        [HttpGet]
        public ActionResult Agrega(string usuario)
        {
            ViewBag.Usuario = usuario;
            return View(new RegistraEmpresaViewModel() { Usuario = usuario });
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Agrega(RegistraEmpresaViewModel modelo)
        {
            if (!ModelState.IsValid) return View(modelo);

            using (var empresa = new RegistraEmpresaHandler())
            {
                try
                {
                    empresa.Registrar(modelo);
                    return RedirectToAction("Lista", new { Usuario = modelo.Usuario });
                }
                catch (Exception ex)
                {
                    ModelState.AddModelError("", ex.Message);
                    return View(modelo);
                }
            }
        }

        [HttpGet]
        public ActionResult Edita(int id)
        {
            using (var empresa = new EditaEmpresaHandler())
            {
                return View(empresa.TraeUno(id));
            }
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edita(RegistraEmpresaViewModel modelo)
        {
            if (!ModelState.IsValid) return View(modelo);

            using (var empresa = new EditaEmpresaHandler())
            {
                try
                {
                    empresa.Actualizar(modelo);
                    return RedirectToAction("Lista", new { Usuario = modelo.Usuario });
                }
                catch (Exception ex)
                {
                    ModelState.AddModelError("", ex.Message);
                    return View(modelo);
                }
            }
        }

        [HttpGet]
        public ActionResult Elimina(int id)
        {
            using (var empresa = new EliminaEmpresaHandler())
            {
                return View(empresa.TraeUno(id));
            }
        }

        [HttpPost]
        public ActionResult EliminaEmpresa(EmpresaViewModel modelo)
        {
            using (var empressa = new EliminaEmpresaHandler())
            {
                try
                {
                    string usuario = modelo.Usuario;
                    empressa.Elimina(modelo.Id);
                    return RedirectToAction("Lista", new { Usuario = usuario });
                }
                catch (Exception ex)
                {
                    ModelState.AddModelError("", ex.Message);
                    return View(modelo);
                }
            }
        }
    }
}

Factoring.Web/Factoring.Web/Controllers/FacturaController.cs
using Factoring.Web.Funcionalidad.Factura;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Factoring.Web.Controllers
{
    public class FacturaController : Controller
    {
        // GET: Factura
        public ActionResult Lista(string empresaId)
        {
            using (var factura = new ListaFacturaHandler())
            {
                ViewBag.EmpresaId = empresaId;
                return View(factura.Listar(empresaId));
            }
            
        }

        public ActionResult Ver(int id, int empresaId)
        {
            using (var factura = new ListaFacturaHandler())
            {
                var obFact = factura.TraeUno(id);
                obFact.EmpresaId = empresaId;
                return View(obFact);
            }
        }

        [HttpGet]
        public ActionResult Agrega(string empresaId)
        {
            return View(new RegistraFacturaViewModel() { EmpresaId = int.Parse(empresaId) });
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Agrega(RegistraFacturaViewModel modelo)
        {
            if (!ModelState.IsValid) return View(modelo);

            using (var factura = new RegistraFacturaHandler())
            {
                try
                {
                    string path = string.Empty;

                    if (modelo.Archivos.Count > 0)
                    {
                        var archivo = modelo.Archivos[0];
                        
                        var fileName = Path.GetFileName(archivo.FileName);
                        var fileExt = Path.GetExtension(fileName);
                        var id = Guid.NewGuid().ToString("N");

                        path = Path.Combine(Server.MapPath("~/Upload"), string.Join("", id, fileExt));
                        archivo.SaveAs(path);
                        modelo.RutaFacturaScaneada = string.Join("", id, fileExt);
                    }

                    factura.Registrar(modelo);
                    return RedirectToAction("Lista", new { EmpresaId = modelo.EmpresaId });
                }
                catch (Exception ex)
                {
                    ModelState.AddModelError("", ex.Message);
                    return View(modelo);
                }
            }
        }

        [HttpGet]
        public ActionResult Edita(int id, int empresaId)
        {
            ViewBag.EmpresaId = empresaId;
            using (var factura = new EditaFacturaHandler())
            {
                var obFactura = factura.TraeUno(id);
                obFactura.EmpresaId = empresaId;
                return View(obFactura);
            }
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edita(RegistraFacturaViewModel modelo)
        {
            if (!ModelState.IsValid) return View(modelo);

            using (var factura = new EditaFacturaHandler())
            {
                try
                {
                    string path = string.Empty;

                    if (modelo.Archivos.Count > 0)
                    {
                        var archivo = modelo.Archivos[0];
                        
                        
                        var fileName = Path.GetFileName(archivo.FileName);
                        var fileExt = Path.GetExtension(fileName);
                        var id = Guid.NewGuid().ToString("N");

                        path = Path.Combine(Server.MapPath("~/Upload"), string.Join("", id, fileExt));
                        archivo.SaveAs(path);
                        modelo.RutaFacturaScaneada = string.Join("", id, fileExt);
                    }
                    
                    factura.Actualizar(modelo);
                    return RedirectToAction("Lista", new { EmpresaId = modelo.EmpresaId });
                }
                catch (Exception ex)
                {
                    ModelState.AddModelError("", ex.Message);
                    return View(modelo);
                }
            }
        }

        [HttpGet]
        public ActionResult Elimina(int id, int empresaId)
        {
            using (var factura = new EliminaFacturaHandler())
            {
                var obFactura = factura.TraeUno(id);
                obFactura.EmpresaId = empresaId;
                return View(obFactura);
            }
        }

        [HttpPost]
        public ActionResult Elimina(FacturaViewModel modelo)
        {
            using (var factura = new EliminaFacturaHandler())
            {
                try
                {
                    int empresaId = modelo.EmpresaId;
                    factura.Elimina(modelo.Id);
                    return RedirectToAction("Lista", new { EmpresaId = empresaId.ToString() });
                }
                catch (Exception ex)
                {
                    ModelState.AddModelError("", ex.Message);
                    return View(modelo);
                }
            }
        }
    }
}

Factoring.Web/Factoring.Web/Controllers/ImagenController.cs
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Factoring.Web.Controllers
{
    public class ImagenController : Controller
    {
        // GET: Imagen
        [HttpGet]
        public FileResult Muestra(string nombre)
        {
            nombre = nombre.Trim().Length == 0 ? "20161222.png" : nombre;
            var path = Path.Combine(Server.MapPath("~/Upload"), nombre);
            string[] partFiles = nombre.Split(new char[] { '.' });

            return new FileStreamResult(
                new FileStream(path, FileMode.Open),
                MimeMapping.GetMimeMapping($"{partFiles[0]}.{partFiles[1]}"));
        }
    }
}

Factoring.Web/Factoring.Web/Views/Factura/Agrega.cshtml
@model Factoring.Web.Funcionalidad.Factura.RegistraFacturaViewModel

@{
    ViewBag.Title = "Agrega";
}

<h2>Agrega</h2>


@using (Html.BeginForm("Agrega", "Factura", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>RegistraFacturaViewModel</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.Numero, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Numero, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Numero, "", new { @class = "text-danger" })
                @Html.HiddenFor(model => model.EmpresaId)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.FechaEmision, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.FechaEmision, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.FechaEmision, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.FechaVencimiento, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.FechaVencimiento, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.FechaVencimiento, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.FechaCobro, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.FechaCobro, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.FechaCobro, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.RucCliente, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.RucCliente, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.RucCliente, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.RazonSocialCliente, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.RazonSocialCliente, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.RazonSocialCliente, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Total, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Total, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Total, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Impuestos, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Impuestos, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Impuestos, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.RutaFacturaScaneada, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @*@Html.EditorFor(model => model.RutaFacturaScaneada, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.RutaFacturaScaneada, "", new { @class = "text-danger" })*@
                @Html.TextBoxFor(m => m.Archivos, new { type = "file", name = "Archivos" })
            </div>
        </div>

        @*<div class="form-group">
            @Html.LabelFor(model => model.EmpresaId, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.EmpresaId, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.EmpresaId, "", new { @class = "text-danger" })
            </div>
        </div>*@

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Grabar" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Regresar a Facturas", "Lista", "Factura", new { EmpresaId = Model.EmpresaId }, new { })
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Factoring.Web/Factoring.Web/Views/Factura/Edita.cshtml
@model Factoring.Web.Funcionalidad.Factura.RegistraFacturaViewModel

@{
    ViewBag.Title = "Edita";
}

<h2>Edita</h2>


@using (Html.BeginForm("Edita","Factura", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>RegistraFacturaViewModel</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.Id)
        @Html.HiddenFor(model => model.EmpresaId)

        <div class="form-group">
            @Html.LabelFor(model => model.Numero, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @*@Html.EditorFor(model => model.Numero, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Numero, "", new { @class = "text-danger" })*@

                @Html.ValueFor(model => model.Numero)
                @Html.HiddenFor(model => model.Numero)
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.FechaEmision, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.FechaEmision, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.FechaEmision, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.FechaVencimiento, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.FechaVencimiento, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.FechaVencimiento, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.FechaCobro, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.FechaCobro, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.FechaCobro, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.RucCliente, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.RucCliente, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.RucCliente, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.RazonSocialCliente, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.RazonSocialCliente, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.RazonSocialCliente, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Total, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Total, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Total, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Impuestos, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Impuestos, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Impuestos, "", new { @class = "text-danger" })
            </div>
        </div>
        <div class="form-group">
            <label>Imagen</label>
            <div class="col-md-10">
                <img src="@Url.Action("Muestra", "Imagen", new { nombre = Model.RutaFacturaScaneada})" />
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.RutaFacturaScaneada, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @*@Html.EditorFor(model => model.RutaFacturaScaneada, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.RutaFacturaScaneada, "", new { @class = "text-danger" })*@
                @Html.TextBoxFor(m => m.Archivos, new { type = "file", name = "Archivos" })
            </div>
        </div>

        @*<div class="form-group">
            @Html.LabelFor(model => model.EmpresaId, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.EmpresaId, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.EmpresaId, "", new { @class = "text-danger" })
            </div>
        </div>*@

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Regresa a Facturas", "Lista", "Factura", new { EmpresaId = Model.EmpresaId }, new { })
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Factoring.Web/Factoring.Web/Views/Factura/Elimina.cshtml
@model Factoring.Web.Funcionalidad.Factura.FacturaViewModel

@{
    ViewBag.Title = "Elimina";
}

<h2>Elimina</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
@using (Html.BeginForm())
{
    <h4>FacturaViewModel</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Numero)
            @Html.HiddenFor(model => model.EmpresaId)
            @Html.HiddenFor(model => model.Id)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Numero)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.FechaEmision)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.FechaEmision)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.FechaVencimiento)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.FechaVencimiento)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.FechaCobro)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.FechaCobro)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.RucCliente)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.RucCliente)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.RazonSocialCliente)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.RazonSocialCliente)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Total)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Total)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Impuestos)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Impuestos)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.RutaFacturaScaneada)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.RutaFacturaScaneada)
        </dd>

        @*<dt>
            @Html.DisplayNameFor(model => model.EmpresaId)
        </dt>*@

        @*<dd>
            @Html.DisplayFor(model => model.EmpresaId)
        </dd>*@

    </dl>

    
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            @Html.ActionLink("Regresa a Lista", "Lista", "Factura", new { EmpresaId = Model.EmpresaId }, new { })
        </div>
    }
</div>

Factoring.Web/Factoring.Web/Views/Factura/Lista.cshtml
@model IEnumerable<Factoring.Web.Funcionalidad.Factura.FacturaViewModel>

@{
    ViewBag.Title = "Lista";
}

<h2>Lista</h2>

<p>
    @Html.ActionLink("Crear Factura", "Agrega", "Factura", new { EmpresaId = ViewBag.EmpresaId }, new { })
</p>
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Numero)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.FechaEmision)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.FechaVencimiento)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.FechaCobro)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.RucCliente)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.RazonSocialCliente)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Total)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Impuestos)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.RutaFacturaScaneada)
        </th>
        
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.Numero)
            @Html.HiddenFor(modelItem => item.EmpresaId)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.FechaEmision)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.FechaVencimiento)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.FechaCobro)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.RucCliente)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.RazonSocialCliente)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Total)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Impuestos)
        </td>
        
        <td>
            @Html.DisplayFor(modelItem => item.RutaFacturaScaneada)
        </td>
        <td>
            <div class="btn-group">
                <button class="btn dropdown-toggle btn-xs" data-toggle="dropdown">
                    <span>
                        <i class="glyphicon glyphicon-cog"></i>
                        <span class="caret"></span>
                    </span>
                </button>
                <ul class="dropdown-menu">
                    <li>
                        @Html.ActionLink("Editar", "Edita", "Factura", new { id = item.Id, EmpresaId = item.EmpresaId }, new { })
                    </li>
                    <li>
                        @Html.ActionLink("Ver", "Ver", "Factura", new { id = item.Id, EmpresaId = item.EmpresaId }, new { })
                    </li>
                    <li>
                        @Html.ActionLink("Eliminar", "Elimina", new { id = item.Id, EmpresaId = item.EmpresaId }, new { })
                    </li>
                </ul>
            </div>
        </td>
    </tr>
}

</table>
<p>
    @Html.ActionLink("Regresa a Empresas", "Lista", "Empresa", new { Usuario = "" }, new { })
</p>

Factoring.Web/Factoring.Web/Views/Factura/Ver.cshtml
@model Factoring.Web.Funcionalidad.Factura.FacturaViewModel

@{
    ViewBag.Title = "Ver";
}

<h2>Ver</h2>

<div>
    <h4>FacturaViewModel</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Numero)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Numero)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.FechaEmision)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.FechaEmision)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.FechaVencimiento)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.FechaVencimiento)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.FechaCobro)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.FechaCobro)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.RucCliente)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.RucCliente)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.RazonSocialCliente)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.RazonSocialCliente)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Total)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Total)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Impuestos)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Impuestos)
        </dd>

        <dt>
            <label>Imagen</label>
        </dt>

        <dd>
            <img src="@Url.Action("Muestra", "Imagen", new { nombre = Model.RutaFacturaScaneada})" />
        </dd>

        @*<dt>
            @Html.DisplayNameFor(model => model.EmpresaId)
        </dt>*@

        @*<dd>
            @Html.DisplayFor(model => model.EmpresaId)
        </dd>*@

    </dl>
</div>
<p>
    @Html.ActionLink("Editar", "Edita", "Factura", new { id = Model.Id, EmpresaId = Model.EmpresaId }, new { }) |
    @Html.ActionLink("Regresa a Lista", "Lista", "Factura", new { EmpresaId = Model.EmpresaId }, new { })
</p>